﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// Attach this script to the weapon at the spawn point
public class Arm : Attachable
{
    public GameObject ProjectilePrefab;

    // Shots
    public float BurstCooldown = 1.0f;
    public int ShotsFiredPerBurst = 1;
    public float TimeBetweenShots = 1.0f;

    private float BurstCooldownTimer;
    private bool BurstWasFired;
    private bool CanShoot;

    public override bool IsArm { get { return true; } }

    private void Start()
    {
        CanShoot = true;
    }

    public void Shoot(Vector2 direction, GameObject shooter)
    {
        if (CanShoot)
        {
            StartCoroutine(ShootBurst(direction, shooter));
        }
    }

    private IEnumerator ShootBurst(Vector2 direction, GameObject shooter)
    {
        CanShoot = false;

        for (int i = 0; i < ShotsFiredPerBurst; i++)
        {
            ShootProjectile(direction, shooter);
            yield return new WaitForSeconds(TimeBetweenShots);
        }

        // Cooldown
        yield return new WaitForSeconds(BurstCooldown);

        CanShoot = true;
    }

    private void ShootProjectile(Vector2 direction, GameObject shootingPlayer)
    {
        // Instantiate projectile and set its color
        GameObject projectile = Instantiate(ProjectilePrefab, transform.position, transform.rotation);
        projectile.GetComponent<ProjectileController>().Boost(direction, shootingPlayer, gameObject);
    }
}
