﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraController : MonoBehaviour
{
    public float smoothTime;
    public float zoomSmoothTime;

    private GameObject[] targets;
    public float sizeMultiplier;
    public float minSize;

    private Vector3 velocity;
    private float zoomVelocity;

    private Bounds bounds;

    private void LateUpdate()
    {
        targets = GameObject.FindGameObjectsWithTag("Player");

        Move();
        Zoom();
    }

    private void Move()
    {
        Vector3 newPosition = Vector3.zero;

        if (targets.Length != 0)
        {
            newPosition = GetCenterPoint();
        }

        newPosition.z = -10;

        transform.position = Vector3.SmoothDamp(transform.position, newPosition, ref velocity, smoothTime);
    }

    private void Zoom()
    {
        float newSize = 0;
        Debug.Log(targets.Length);
        if (targets.Length != 0)
        {
            newSize = (bounds.size.x * sizeMultiplier) / (Camera.main.aspect * 2);
            if (newSize < minSize) { newSize = minSize; }
        }
        else
        {
            Debug.Log("NoPlayers");
            newSize = 20;
        }

        Camera.main.orthographicSize = Mathf.SmoothDamp(Camera.main.orthographicSize, newSize, ref zoomVelocity, zoomSmoothTime);
    }

    Vector3 GetCenterPoint()
    {
        if(targets.Length == 1)
        {
            return targets[0].transform.position;
        }

        bounds = new Bounds(targets[0].transform.position, Vector3.zero);

        foreach (var target in targets)
        {
            bounds.Encapsulate(target.transform.position);
        }

        return bounds.center;
    }


}
